# 🌟 Showcase

This is a selection of sites and apps using Typesense.

> As of Mar 2022 we have around 2.7M Docker pulls. So the list below is a tiny sample of everyone using Typesense.
> 
> If you are a Typesense user, an easy way to contribute back to the ecosystem is by sharing that you are indeed using Typesense. This helps build confidence among potential new users who are exploring Typesense.
> So we invite and welcome you to add your own sites / apps to the list above. Please edit this file and send us a PR 🙏 


| Name        | Description |
| ----------- | ----------- |
| [Aviyel](https://aviyel.com) | Open-source community platform |
| [Back Right Up](https://backrightup.com) | Automatic Azure Devops backups |
| [BetaSeries](https://www.betaseries.com/) | TV shows and movies recommendation, using Typesense to search into 4M+ international records |
| [Bikifi](https://bikifi.com/) | A free education platform that brings premium educational content to anyone, anywhere in Turkey |
| [Bookology](https://play.google.com/store/apps/details?id=com.imihirpaldhikar.bookology) | "I am using Typesense for searching the the books listed on the platform. I switched from Algolia to Typesense because it is more convenient to only pay for the underlying infrastructure rather then paying for search queries. I will always use Typesense in my future projects." - @imihirpaldhikar
| [Cults.](https://cults3d.com) | Find designs for 3D-printing. *We are very happy with our switch to Typesense, making it a breeze to setup and have pertinent results right from the start* |
| [datarequests.org](https://www.datarequests.org/) | Search backend for the [company database](https://www.datarequests.org/company) that allows users to easily find the contact details for privacy-related requests |
| [Dave & Adams Card World](https://www.dacardworld.com) | E-commerce platform for collectibles like sports cards, gaming cards, comics, or autographed memorabilia |
| [DiscMaster](http://discmaster.textfiles.com/search) | Search 94 million vintage computer files from archive.org |
| [Echidna Sewing](https://www.echidnasewing.com.au) | Echidna Sewing is one of Australia’s largest sewing machine dealers |
| [ElbiseBul](https://www.elbisebul.com/) | E-commerce |
| [FlyGRN](https://flygrn.com) | Flight Ticket Search Engine that ranks flights on carbon emissions and gives greener alternatives |
| [furn.nl](https://furn.nl) | Dutch furniture comparison website |
| [GlobalTill](https://www.globaltill.com) | Omnichannel Retail Management System |
| [Grafikart](https://www.grafikart.fr/) | Learning resources library |
| [Granthappura](https://gpura.org/) | A free-licensed digitized artifacts archive related to Kerala from multiple languages. [Github Link](https://github.com/indic-archive/omeka-typesense-search) |
| [Have A Class](https://haveaclass.com/) | Find the perfect teacher online |
| [Hem](https://hem.com) | A premium furniture brand for the auction houses of tomorrow |
| [Iconduck](https://iconduck.com) | Site to search for open source icons |
| [Instatus](https://instatus.com) | System Status Pages Platform |
| [Job Ads Now](https://www.jobadsnow.com) | Job Ads Now is a jobs search engine focusing on the best candidate experience. Blazing fast search and filters by salary, location, bonus and more. You can also read the job highlights (TL;DR) for each job identified from the origina job post using AI | 
| [Jobsort](https://www.jobsort.com/) | Job search engine for developers, by developers (quicksort for tech jobs.) |
| [Lawyaw](https://lawyaw.com) | Lawyaw provides easy to use document automation software that helps legal practices save time and avoid mistakes without sacrificing quality. *"Typesense is used as our search index and works great to search, sort and facet thousands of our Court forms each day. We look forward to working with Typesense for years to come as it continues to mature!" - @tpayne84* | 
| [Magny SaaS search bar](https://magny.io) | Magny is a SaaS platform that helps implement command palettes, which significantly decreases the time users find anything in your app, leveraging the user experience and efficiency. |
| [MyHearty](https://myhearty.my) | A one-stop charity website to fundraise, donate, volunteer and apply for aids. It comes with a full-featured search UI (instant search, geosearch) for campaigns, volunteer events and aids. |
| [NeoDB](https://neodb.social/) | An open source project and free service to help users in Fediverse manage, share and discover collections, reviews and ratings for culture products, with a searchable catalog of over a million books, movies, music, podcasts, games and performances. |
| [Neolace](https://www.neolace.com) | Knowledge graph platform (combines a wiki and a graph database) |
| [New York University Databrary](https://nyu.databrary.org/) | Video documentation library |
| [Oddle Eats](https://eats.oddle.me) | Food Delivery Service in Singapore | 
| [OpenTacos](https://tacos.openbeta.io) | Free and open source rock climbing route wiki |
| [Orders Made Simple](https://ordersmadesimple.com) | A Stock ordering platform helping to connect hospitality and catering venues with their suppliers |
| [Otaku Square](https://www.otakusquare.com) | Online retailer for pop-culture (e.g. anime, games, movies) merchandise |
| [Plaza](https://www.useplaza.com) | Live-shopping platform |
| [Popcorn](https://onpopcorn.com) | Zoom meets Snapchat, async video chat app |
| [Project Seldon](https://projectseldon.org) | A free and unbiased analysis platform for understanding societies and systems of government. |
| [Puey Ungphakorn Institute for Economic Research](https://www.pier.or.th) | A research institute in Thailand |
| [Read This Twice](https://www.readthistwice.com/) | Book discovery platform uses typesense to power the book/people search |
| [Rushtix](https://rushtix.com) | Live Comedy Shows platform |
| [Service Foods](https://www.servicefoods.co.nz) | One of New Zealand's largest privately family owned and operated food service distribution businesses |
| [Syracuse University](https://syracuse.edu) | A private research university in Syracuse, New York. [Visit our live typesense demo!](https://typesense-demo.dev3.digitalservices.syr.edu) |
| [Trading Strategy](https://tradingstrategy.ai/blog/world-fastest-token-search) | Algorithmic trading protocol for decentralised markets |
| [Upnext](https://www.getupnext.com) | Save, organize and focus on your personal content library |
| [What's In My Jar](https://whatsinmyjar.com) | Skincare Research platform |

### Typesense Demos

| Name        | Description |
| ----------- | ----------- |
| [Recipe Search](https://recipe-search.typesense.org/) | A site that showcases Typesense in action on a 2 Million recipe database, with the ability to filter by ingredients.|
| [Linux Commit History Search](https://linux-commits-search.typesense.org/) | A site that indexes 1M linux commit messages in Typesense and lets you browse, search and filter through the commits.|
| [Books Search](https://books-search.typesense.org/) | A site that showcases Typesense in action on a 28 Million books database from [OpenLibrary](https://openlibrary.org/), with the ability to filter by authors and subject.  |
| [MusicBrainz Songs Search](https://songs-search.typesense.org/) | A site that showcases Typesense in action on a 32 Million Songs database from [MusicBrainz](https://musicbrainz.org/) |
| [2020 US Presidential Candidates' Speeches Search](https://biden-trump-speeches-search.typesense.org/) | Instantly Search speeches of US Presidential Candidates side-by-side. |
| [E-commerce Store Browsing Experience](https://ecommerce-store.typesense.org/) | A site that showcases how to build an e-commerce storefront browsing experience with Typesense. |
